import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _typeof from "@babel/runtime/helpers/esm/typeof";
import _construct from "@babel/runtime/helpers/esm/construct";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

/**
  * gowiny-vue-class v1.0.61
  * https://gitee.com/gowiny/vue-class
  *
  * (c) 2022-present gowiny
  * @license MIT
  *
  * Date: 2022-03-26T05:18:37Z
  */
import { isNull, isFunction, clone, getClassDefaultValue } from '@gowiny/js-utils';
import { ref, computed } from 'vue';
var EXCLUDE_SUPER_PROPS = ['data', 'setup'];

function defineProxy(proxy, key, target) {
  Object.defineProperty(proxy, key, {
    get: function get() {
      return target[key].value;
    },
    set: function set(value) {
      target[key].value = value;
    },
    enumerable: true,
    configurable: true
  });
}

function getSuper(Ctor) {
  var superProto = Object.getPrototypeOf(Ctor.prototype);

  if (!superProto) {
    return undefined;
  }

  return superProto.constructor;
}

function getOwn(value, key) {
  return value.hasOwnProperty(key) ? value[key] : undefined;
}

function copyNotExistProps(src, dest, propNames) {
  var result;

  if (src) {
    propNames = propNames || Object.getOwnPropertyNames(src);

    if (propNames.length > 0) {
      result = {};
      propNames.forEach(function (item) {
        var srcVal = src[item];

        if (!isNull(srcVal) && isNull(dest[item])) {
          result[item] = srcVal;
        }
      });
    }

    result = result || _objectSpread({}, src);
  }

  return result;
}

var defaultBeforeFactoryHandle = function defaultBeforeFactoryHandle(ctx) {
  var options = ctx.options;
  var Ctor = ctx.classType;
  var proto = Ctor.prototype;
  var propNames = Object.getOwnPropertyNames(proto); // Inject base options as a mixin

  var base = getOwn(Ctor, '__b');

  if (base) {
    options.mixins = options.mixins || [];
    options.mixins.unshift(base);
  }

  options.methods = _objectSpread({}, options.methods);
  options.computed = _objectSpread({}, options.computed);
  propNames.forEach(function (key) {
    if (key === 'constructor') {
      return;
    } // hooks


    if (Ctor.__h.indexOf(key) > -1) {
      options[key] = proto[key];
      return;
    }

    var descriptor = Object.getOwnPropertyDescriptor(proto, key); // methods

    if (typeof descriptor.value === 'function') {
      options.methods[key] = descriptor.value;
      return;
    } // computed properties


    if (descriptor.get || descriptor.set) {
      options.computed[key] = {
        get: descriptor.get,
        set: descriptor.set
      };
      return;
    }
  }); // from Vue Loader

  var injections = ['render', 'ssrRender', '__file', '__cssModules', '__scopeId', '__hmrId'];
  injections.forEach(function (key) {
    if (Ctor[key]) {
      options[key] = Ctor[key];
    }
  }); // Handle super class options

  var Super = getSuper(Ctor);

  if (Super) {
    var superOptions = Super.__vccOpts;
    var extendOptions = copyNotExistProps(superOptions, options, Ctor.__h);

    if (extendOptions.watch && options.watch) {
      extendOptions.watch = copyNotExistProps(extendOptions.watch, options.watch);
    }

    EXCLUDE_SUPER_PROPS.forEach(function (item) {
      delete extendOptions[item];
    });
    options["extends"] = extendOptions;
  }

  return options;
};

var defaultDataFactory = function defaultDataFactory(ctx) {
  var result = function result() {
    var Ctor = ctx.classType;
    var excludeProps = ctx.excludeProps;
    var data = new Ctor();
    var plainData = {};
    var dataKeys = Object.keys(data);
    dataKeys.forEach(function (key) {
      if (data[key] === undefined || data[key] && data[key].__s || excludeProps.indexOf(key) > -1) {
        return;
      }

      plainData[key] = ref(data[key]);
      defineProxy(data, key, plainData);
    });
    return plainData;
  };

  return result;
};

var defaultAfterFactoryHandle = function defaultAfterFactoryHandle(ctx) {
  var options = ctx.options;

  var excludeKeys = _toConsumableArray(ctx.excludeKeys);

  if (options.computed) {
    excludeKeys.push.apply(excludeKeys, _toConsumableArray(Object.keys(options.computed)));
  }

  if (options.props) {
    excludeKeys.push.apply(excludeKeys, _toConsumableArray(Object.keys(options.props)));
  }

  var excludeMethods = [].concat(_toConsumableArray(excludeKeys), _toConsumableArray(ctx.excludeMethods));
  var excludeProps = [].concat(_toConsumableArray(excludeKeys), _toConsumableArray(ctx.excludeProps));
  excludeMethods.forEach(function (key) {
    delete options.methods[key];
  });
  ctx.excludeProps = excludeProps;
  return options;
};

var OptionsContextImpl = /*#__PURE__*/function () {
  function OptionsContextImpl(options, target) {
    _classCallCheck(this, OptionsContextImpl);

    _defineProperty(this, "options", void 0);

    _defineProperty(this, "classType", void 0);

    _defineProperty(this, "dataFactory", void 0);

    _defineProperty(this, "beforeHandle", void 0);

    _defineProperty(this, "afterHandle", void 0);

    _defineProperty(this, "attrs", new Map());

    _defineProperty(this, "factoryMap", {});

    _defineProperty(this, "excludeKeys", []);

    _defineProperty(this, "excludeMethods", []);

    _defineProperty(this, "excludeProps", []);

    this.options = options;
    this.classType = target;
    this.dataFactory = defaultDataFactory;
    this.beforeHandle = defaultBeforeFactoryHandle;
    this.afterHandle = defaultAfterFactoryHandle;
  }

  _createClass(OptionsContextImpl, [{
    key: "addFactory",
    value: function addFactory(factory) {
      this.factoryMap[factory.name] = factory;
    }
  }, {
    key: "removeFactory",
    value: function removeFactory(name) {
      delete this.factoryMap[name];
    }
  }, {
    key: "hasFactory",
    value: function hasFactory(name) {
      return Reflect.has(this.factoryMap, name);
    }
  }, {
    key: "getOrderedFactories",
    value: function getOrderedFactories() {
      var list = Object.values(this.factoryMap);
      list = list.sort(function (o1, o2) {
        return o1.order - o2.order;
      });
      return list;
    }
  }, {
    key: "clearFactories",
    value: function clearFactories() {
      var _this = this;

      var keys = Object.keys(this.factoryMap);
      keys.forEach(function (key) {
        delete _this.factoryMap[key];
      });
    }
  }, {
    key: "getAttr",
    value: function getAttr(name) {
      return this.attrs.get(name);
    }
  }, {
    key: "hasAttr",
    value: function hasAttr(name) {
      return this.attrs.has(name);
    }
  }, {
    key: "setAttr",
    value: function setAttr(name, value) {
      this.attrs.set(name, value);
    }
  }, {
    key: "removeAttr",
    value: function removeAttr(name) {
      this.attrs["delete"](name);
    }
  }, {
    key: "clearAttrs",
    value: function clearAttrs() {
      this.attrs.clear();
    }
  }]);

  return OptionsContextImpl;
}();

var VueImpl = /*#__PURE__*/function () {
  function VueImpl() {
    _classCallCheck(this, VueImpl);
  }

  _createClass(VueImpl, null, [{
    key: "__vccOpts",
    get: function get() {
      // Early return if `this` is base class as it does not have any options
      if (this === Vue) {
        return {};
      }

      var Ctor = this;
      var cache = getOwn(Ctor, '__c');

      if (cache) {
        return cache;
      } // If the options are provided via decorator use it as a base


      var options = _objectSpread({}, getOwn(Ctor, '__o'));

      var optionsContext = new OptionsContextImpl(options, Ctor);
      var decorators = getOwn(Ctor, '__d');

      if (decorators) {
        decorators.forEach(function (fn) {
          return fn(optionsContext);
        });
      }

      if (optionsContext.beforeHandle) {
        options = optionsContext.beforeHandle(optionsContext);
        optionsContext.options = options;
      }

      var factories = optionsContext.getOrderedFactories();

      for (var i = 0; i < factories.length; i++) {
        var item = factories[i];
        options = item.handle(optionsContext);
        optionsContext.options = options;
      }

      if (optionsContext.afterHandle) {
        options = optionsContext.afterHandle(optionsContext);
        optionsContext.options = options;
      }

      var dataFactory = optionsContext.dataFactory || defaultDataFactory;
      options.data = dataFactory(optionsContext);
      Ctor.__c = options;
      return options;
    }
  }, {
    key: "registerHooks",
    value: function registerHooks(keys) {
      var _this$__h;

      (_this$__h = this.__h).push.apply(_this$__h, _toConsumableArray(keys));
    }
  }, {
    key: "with",
    value: function _with(Props) {
      var propsMeta = new Props();
      var props = {};
      Object.keys(propsMeta).forEach(function (key) {
        var meta = propsMeta[key];
        props[key] = meta !== null && meta !== void 0 ? meta : null;
      });

      var PropsMixin = /*#__PURE__*/function (_this2) {
        _inherits(PropsMixin, _this2);

        var _super = _createSuper(PropsMixin);

        function PropsMixin() {
          _classCallCheck(this, PropsMixin);

          return _super.apply(this, arguments);
        }

        return _createClass(PropsMixin);
      }(this);

      _defineProperty(PropsMixin, "__b", {
        props: props
      });

      return PropsMixin;
    }
  }]);

  return VueImpl;
}();

_defineProperty(VueImpl, "__h", ['beforeCreate', 'created', 'beforeMount', 'mounted', 'beforeUnmount', 'unmounted', 'beforeUpdate', 'updated', 'activated', 'deactivated', 'render', 'errorCaptured', 'serverPrefetch']);

var Vue = VueImpl;
var vuePlugin = {
  install: function install(app, options) {
    app.config.unwrapInjectedRef = true;
    var hooks = options.hooks;

    if (hooks) {
      Vue.registerHooks(hooks);
    }
  }
};

function Options(options) {
  return function (Component) {
    Component.__o = options;
    return Component;
  };
}

function getOptionsByClass(Ctor) {
  var options;

  if (Ctor.__vccOpts) {
    options = Ctor.__vccOpts;
  } else {
    options = Ctor;
  } //console.log('getOptionsByClass Ctor',Ctor)
  //console.log('getOptionsByClass options',options)


  return options;
}

function mergeSetup() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  if (!args) {
    return;
  } else if (args.length == 1) {
    return args[0];
  } else {
    var result = {};
    args.forEach(function (item) {
      if (!item) {
        return;
      } else if (isFunction(item)) {
        result.render = item;
      } else {
        Object.assign(result, item);
      }
    });
    return result;
  }
}

function createDecorator(factory) {
  return function (target, key, index) {
    var Ctor = typeof target === 'function' ? target : target.constructor;

    if (!Ctor.__d) {
      Ctor.__d = [];
      Ctor.__d.__ctor = Ctor;
    } else if (Ctor.__d.__ctor !== Ctor) {
      Ctor.__d = [].concat(Ctor.__d);
      Ctor.__d.__ctor = Ctor;
    }

    if (typeof index !== 'number') {
      index = undefined;
    }

    Ctor.__d.push(function (ctx) {
      return factory(ctx, key, index);
    });
  };
}

function mixins() {
  var _class;

  for (var _len2 = arguments.length, Ctors = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    Ctors[_key2] = arguments[_key2];
  }

  return _class = /*#__PURE__*/function (_Vue) {
    _inherits(MixedVue, _Vue);

    var _super2 = _createSuper(MixedVue);

    function MixedVue() {
      var _this3;

      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      _classCallCheck(this, MixedVue);

      _this3 = _super2.call.apply(_super2, [this].concat(args));
      Ctors.forEach(function (Ctor) {
        var data = _construct(Ctor, args);

        Object.keys(data).forEach(function (key) {
          _this3[key] = data[key];
        });
      });
      return _this3;
    }

    return _createClass(MixedVue);
  }(Vue), _defineProperty(_class, "__b", {
    mixins: Ctors.map(function (Ctor) {
      return Ctor.__vccOpts;
    })
  }), _class;
}

function create$7(params, target, propertyKey, descriptor) {
  createDecorator(function (ctx, key) {
    var options = ctx.options;

    if (!options.watch) {
      options.watch = {};
    }

    var name = params || key;
    var watch = options.watch;
    watch[name] = descriptor === null || descriptor === void 0 ? void 0 : descriptor.value;
    ctx.excludeKeys.push(key);
  })(target, propertyKey);
}

function Watch(target) {
  var propertyKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var descriptor = arguments.length > 2 ? arguments[2] : undefined;

  if (propertyKey) {
    create$7(propertyKey, target, propertyKey, descriptor);
  } else {
    var params = target;
    return function (target, propertyKey, descriptor) {
      create$7(params, target, propertyKey, descriptor);
    };
  }
}

function create$6(params, target, propertyKey, descriptor) {
  createDecorator(function (ctx, key) {
    var options = ctx.options;

    if (!options.props) {
      options.props = {};
    }

    var props = options.props;
    var oldDefault = params["default"];

    var defType = _typeof(oldDefault);

    if (descriptor) {
      //定义在方法上
      if (defType === 'undefined') {
        params["default"] = function () {
          return descriptor.value;
        };
      }
    } else {
      //定义在属性上
      if (defType === 'object') {
        params["default"] = clone(oldDefault);
      } else if (defType === 'undefined') {
        params["default"] = getClassDefaultValue(ctx.classType, key);
      }
    }

    props[key] = params;
  })(target, propertyKey);
}

function Prop(target) {
  var propertyKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var descriptor = arguments.length > 2 ? arguments[2] : undefined;

  if (propertyKey) {
    create$6({}, target, propertyKey, descriptor);
  } else {
    var params = target;
    return function (target, propertyKey, descriptor) {
      create$6(params, target, propertyKey, descriptor);
    };
  }
}

function create$5(params, target, propertyKey, descriptor) {
  createDecorator(function (ctx, key) {
    var options = ctx.options;
    options.methods = options.methods || {};
    var name = params || key;

    options.methods[key] = function () {
      var _this$$store;

      for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }

      return (_this$$store = this.$store).dispatch.apply(_this$$store, [name].concat(args));
    };
  })(target, propertyKey);
}

function Action(target) {
  var propertyKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var descriptor = arguments.length > 2 ? arguments[2] : undefined;

  if (propertyKey) {
    create$5(propertyKey, target, propertyKey);
  } else {
    var params = target;
    return function (target, propertyKey, descriptor) {
      create$5(params, target, propertyKey);
    };
  }
}

function create$4(params, target, propertyKey, descriptor) {
  createDecorator(function (ctx, key) {
    var options = ctx.options;
    options.computed = options.computed || {};
    var name = params || key;

    options.computed[key] = function () {
      var getter = this.$store.getters[name];
      return getter;
    };
  })(target, propertyKey);
}

function Getter(target) {
  var propertyKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var descriptor = arguments.length > 2 ? arguments[2] : undefined;

  if (propertyKey) {
    create$4(propertyKey, target, propertyKey);
  } else {
    var params = target;
    return function (target, propertyKey, descriptor) {
      create$4(params, target, propertyKey);
    };
  }
}

function create$3(params, target, propertyKey, descriptor) {
  createDecorator(function (ctx, key) {
    var options = ctx.options;
    options.computed = options.computed || {};
    var arr = params ? params.split(/[/.]/) : undefined;

    options.computed[key] = function () {
      var data = this.$store.state;

      if (!arr) {
        return data[key];
      } else {
        arr.forEach(function (item) {
          data = data[item];
        });
        return data;
      }
    };
  })(target, propertyKey);
}

function State(target) {
  var propertyKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var descriptor = arguments.length > 2 ? arguments[2] : undefined;

  if (propertyKey) {
    create$3(propertyKey, target, propertyKey);
  } else {
    var params = target;
    return function (target, propertyKey, descriptor) {
      create$3(params, target, propertyKey);
    };
  }
}

function create$2(params, target, propertyKey, descriptor) {
  createDecorator(function (ctx, key) {
    var options = ctx.options;
    options.methods = options.methods || {};
    var dname = params || key;

    options.methods[key] = function () {
      var _this$$store2;

      for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
        args[_key5] = arguments[_key5];
      }

      return (_this$$store2 = this.$store).commit.apply(_this$$store2, [dname].concat(args));
    };
  })(target, propertyKey);
}

function Mutation(target) {
  var propertyKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var descriptor = arguments.length > 2 ? arguments[2] : undefined;

  if (propertyKey) {
    create$2(propertyKey, target, propertyKey);
  } else {
    var params = target;
    return function (target, propertyKey, descriptor) {
      create$2(params, target, propertyKey);
    };
  }
}

function create$1(params, target, propertyKey, descriptor) {
  createDecorator(function (ctx, key) {
    var options = ctx.options;

    if (!options.inject) {
      options.inject = {};
    }

    var data = Object.assign({
      from: key
    }, params);

    if (isNull(data["default"])) {
      if (descriptor !== null && descriptor !== void 0 && descriptor.value) {
        data["default"] = function () {
          return descriptor.value;
        };
      } else {
        data["default"] = getClassDefaultValue(ctx.classType, key);
      }
    }

    var inject = options.inject;
    inject[key] = data;
    ctx.excludeKeys.push(key);
  })(target, propertyKey);
}

function Inject(target) {
  var propertyKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var descriptor = arguments.length > 2 ? arguments[2] : undefined;

  if (propertyKey) {
    create$1({
      from: propertyKey
    }, target, propertyKey, descriptor);
  } else {
    var targetType = _typeof(target);

    var params = targetType === 'string' || targetType === 'symbol' ? {
      from: target
    } : target;
    return function (target, propertyKey, descriptor) {
      create$1(params, target, propertyKey, descriptor);
    };
  }
}

function create(params, target, propertyKey, descriptor) {
  createDecorator(function (ctx, key) {
    var options = ctx.options;

    if (!options.provide) {
      var provideFun = function provideFun() {
        var _this4 = this;

        var result = Object.create(null);

        var _iterator = _createForOfIteratorHelper(provideFun.values),
            _step;

        try {
          var _loop = function _loop() {
            var _step$value = _slicedToArray(_step.value, 2),
                key = _step$value[0],
                params = _step$value[1];

            //默认响应式设置
            if (params.ref === false) {
              result[params.name] = _this4[key];
            } else {
              result[params.name] = computed(function () {
                return _this4[key];
              });
            }
          };

          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            _loop();
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }

        var _iterator2 = _createForOfIteratorHelper(provideFun.funs),
            _step2;

        try {
          var _loop2 = function _loop2() {
            var _step2$value = _slicedToArray(_step2.value, 2),
                key = _step2$value[0],
                params = _step2$value[1];

            result[params.name] = function () {
              return _this4[key].apply(_this4, arguments);
            };
          };

          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            _loop2();
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }

        return result;
      };

      provideFun.values = new Map();
      provideFun.funs = new Map();
      options.provide = provideFun;
    }

    var provide = options.provide;

    if (descriptor !== null && descriptor !== void 0 && descriptor.value) {
      provide.funs.set(key, params);
    } else if (descriptor !== null && descriptor !== void 0 && descriptor.get) {
      provide.values.set(key, params);
    } else {
      provide.values.set(key, params);
    }
  })(target, propertyKey);
}

function Provide(target) {
  var propertyKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var descriptor = arguments.length > 2 ? arguments[2] : undefined;

  if (propertyKey) {
    create({
      name: propertyKey
    }, target, propertyKey, descriptor);
  } else {
    var targetType = _typeof(target);

    var params = targetType === 'string' || targetType === 'symbol' ? {
      name: target
    } : target;
    return function (target, propertyKey, descriptor) {
      create(params, target, propertyKey, descriptor);
    };
  }
}

export { Action, Getter, Inject, Mutation, Options, Prop, Provide, State, Vue, Watch, vuePlugin as default, getOptionsByClass, mergeSetup, mixins };
